/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.statistik;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.statistik.boundary.AbstractStatistikLaufSearchParameters;
import de.ivu.elect.business.statistik.boundary.StatistikLaufChangeEvent;
import de.ivu.elect.business.statistik.boundary.StatistikLaufConversationStore;
import de.ivu.elect.business.statistik.boundary.StatistikLaufExtendedDAO;
import de.ivu.elect.business.statistik.boundary.StatistikLaufSearch;
import de.ivu.elect.business.statistik.boundary.StatistikLaufSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.statistik.entity.StatistikLauf;
import de.ivu.elect.business.statistik.entity.StatistikLaufMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStatistikLaufSearchView.COMPONENT_NAME)
@View(viewId = AbstractStatistikLaufSearchView.VIEW_ID, useCase = UseCasePermission.STATISTIK_LAUF_SEARCH)
public abstract class AbstractStatistikLaufSearchView extends AbstractElectSearchView<StatistikLauf> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "statistikLaufSearchView";
  
  public static final String VIEW_ID = "/statistik/statistik-lauf-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStatistikLaufSearchView requestHandler;

  @Inject
  private transient StatistikLaufExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StatistikLaufConversationStore.class)
  protected transient StatistikLaufConversationStore conversationStore;

  @Inject
  protected transient StatistikLaufSearch search;

  @Inject
  @ConversationGroup(AbstractStatistikLaufSearchParameters.class)
  protected transient StatistikLaufSearchParameters searchParameters;

  @Inject
  protected transient StatistikLaufMeta entityMeta;

  public AbstractStatistikLaufSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public StatistikLauf getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(StatistikLauf entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StatistikLaufSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<StatistikLauf> getEagerLoadingCollector() {
    return EagerLoadingCollector.<StatistikLauf> create();
  }

  @Override
  public List<StatistikLauf> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<StatistikLauf> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStatistikLaufChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StatistikLaufChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStatistikLaufSearchView {

    @View
    @Inject
    private transient Instance<AbstractStatistikLaufSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStatistikLaufSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
